// TradingSystemDlg.cpp : implementation file
//

#include "stdafx.h"
#include <cassert>
#include "Common.h"
#include "Helper.h"
#include "TradingSystem.h"
#include "TradingSystemDlg.h"
#include "TradingSystemReqDlg.h"

const long CTradingSystemDlg::SHOW_COUNT = 5;
const long CTradingSystemDlg::MAX_INTERVAL = 500;
const CString CTradingSystemDlg::NAME_SPLITTER(" - ");

CTradingSystemDlg::CTradingSystemDlg(CWnd* pParent /*=NULL*/)
                           : CDialog(CTradingSystemDlg::IDD, pParent)
{
   m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTradingSystemDlg::DoDataExchange(
                           CDataExchange* pDX)
{
   CDialog::DoDataExchange(pDX);
   DDX_Control(pDX, IDC_LBL_DATA_CONNECTION, m_lblDataConnection);

   DDX_Control(pDX, IDC_BTN_REQUEST_DEFINITION, m_btnRequestDefinition);
   DDX_Control(pDX, IDC_CMB_DEFINITION, m_cmbDefinition);
   DDX_Control(pDX, IDC_LSV_DEF_PARAMETERS, m_lvDefParameters);
   DDX_Control(pDX, IDC_LSV_DEF_TRADES, m_lvDefTrades);
   DDX_Control(pDX, IDC_LSV_DEF_ENTRY_EXITS, m_lvDefEntryExits);
   DDX_Control(pDX, IDC_LBL_DEF_ABBREVIATION, m_lblDefAbbreviation);
   DDX_Control(pDX, IDC_LBL_DEF_COMMISSION, m_lblDefCommission);
   DDX_Control(pDX, IDC_LBL_DEF_COMMISSION_TYPE, m_lblDefCommissionType);

   DDX_Control(pDX, IDC_CMB_TRADING_SYSTEM, m_cmbTradingSystem);

   DDX_Control(pDX, IDC_ED_DEFINITION_NAME, m_edDefinitionName);

   DDX_Control(pDX, IDC_BTN_REQUEST, m_btnRequest);
   DDX_Control(pDX, IDC_BTN_REMOVE, m_btnRemove);
   DDX_Control(pDX, IDC_BTN_REMOVE_ALL, m_btnRemoveAll);

   DDX_Control(pDX, IDC_LBL_STATUS, m_lblStatus);

   DDX_Text(pDX, IDC_LBL_DEFINITION_NAME, m_DefinitionName);
   DDX_Control(pDX, IDC_LSV_PARAMETERS, m_lvParameters);
   DDX_Text(pDX, IDC_LBL_BASE_EXPRESSION, m_BaseExpression);
   DDX_Text(pDX, IDC_LBL_RANGE_START, m_RangeStart);
   DDX_Text(pDX, IDC_LBL_RANGE_END, m_RangeEnd);
   DDX_Text(pDX, IDC_LBL_INTRADAY_PERIOD, m_IntradayPeriod);
   DDX_Text(pDX, IDC_LBL_HISTORICAL_PERIOD, m_HistoricalPeriod);
   DDX_Text(pDX, IDC_LBL_INCLUDE_END, m_IncludeEnd);
   DDX_Text(pDX, IDC_LBL_SESSIONS_FILTER, m_SessionsFilter);
   DDX_Text(pDX, IDC_LBL_CONTINUATION, m_Continuation);
   DDX_Text(pDX, IDC_LBL_EQUALIZE_CLOSES, m_EqualizeCloses);
   DDX_Text(pDX, IDC_LBL_DAYS_BEFORE_EXPIRATION, m_DaysBeforeExpiration);
   DDX_Text(pDX, IDC_LBL_SESSION_FLAGS, m_SessionFlags);
   DDX_Text(pDX, IDC_LBL_SUBSCRIPTION_LEVEL, m_SubscriptionLevel);
   DDX_Text(pDX, IDC_LBL_RECALC_PERIOD, m_RecalcPeriod);

   DDX_Control(pDX, IDC_LBL_ERROR, m_lblError);

   DDX_Control(pDX, IDC_TAB_TRADE_STATISTIC, m_tabTradeStatistic);

   DDX_Control(pDX, IDC_CMB_TRADES, m_cmbTrades);

   DDX_Control(pDX, IDC_LSV_LAST_TRADES, m_lvLastTrades);
   DDX_Control(pDX, IDC_LSV_TRADES, m_lvTrades);

   DDX_Control(pDX, IDC_LSV_LAST_STATISTICS, m_lvLastStatistics);
   DDX_Control(pDX, IDC_LSV_STATISTICS, m_lvStatistics);

   DDX_Control(pDX, IDC_ED_TAG_NAME, m_edTagName);
   DDX_Control(pDX, IDC_ED_TAG_VALUE, m_edTagValue);

   DDX_Control(pDX, IDC_ED_FILTER_START_INDEX, m_edStart);
   DDX_Control(pDX, IDC_SPN_FILTER_START_INDEX, m_spnStart);
   DDX_Control(pDX, IDC_ED_FILTER_END_INDEX, m_edEnd);
   DDX_Control(pDX, IDC_SPN_FILTER_END_INDEX, m_spnEnd);
   DDX_Control(pDX, IDC_BTN_SHOW, m_btnShow);

   DDX_Control(pDX, IDC_LBL_STAT_RECS_COUNT, m_lblStatsFltrRecsCount);
   DDX_Control(pDX, IDC_LBL_STAT_ALL_RECS_COUNT, m_lblStatsAllRecsCount);

   DDX_Control(pDX, IDC_LBL_TRADE_RECS_COUNT, m_lblTradesFltrRecsCount);
   DDX_Control(pDX, IDC_LBL_TRADE_ALL_RECS_COUNT, m_lblTradesAllRecsCount);

   DDX_Control(pDX, IDC_LSV_LAST_TRADES_RELATIONS, m_lvLastTradeItems);
   DDX_Control(pDX, IDC_LSV_TRADES_RELATIONS, m_lvTradeItems);

   DDX_Control(pDX, IDC_CMB_LAST_TRADE_ITEMS, m_cmbLastTradeItems);
   DDX_Control(pDX, IDC_CMB_TRADES_ITEMS, m_cmbTradeItems);

   DDX_Control(pDX, IDC_LBL_LAST_TRADES_RELATIONS, m_lblLastRelations);
   DDX_Control(pDX, IDC_LBL_TRADES_RELATIONS, m_lblRelations);
}

BEGIN_MESSAGE_MAP(CTradingSystemDlg, CDialog)
   ON_WM_PAINT()
   ON_WM_QUERYDRAGICON()
   ON_WM_DESTROY()
   ON_BN_CLICKED(IDC_BTN_REMOVE, OnBnClickedBtnRemove)
   ON_BN_CLICKED(IDC_BTN_REMOVE_ALL, OnBnClickedBtnRemoveAll)
   ON_BN_CLICKED(IDC_BTN_REQUEST, OnBnClickedBtnRequest)
   ON_BN_CLICKED(IDC_BTN_SHOW, OnBnClickedBtnShow)
   ON_CBN_SELCHANGE(IDC_CMB_TRADING_SYSTEM, OnCbnSelChangeCmbTradingSystem)
   ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_FILTER_START_INDEX, OnDeltaposSpnStart)
   ON_NOTIFY(UDN_DELTAPOS, IDC_SPN_FILTER_END_INDEX, OnDeltaposSpnEnd)
   ON_BN_CLICKED(IDC_BTN_REQUEST_DEFINITION, OnBnClickedBtnRequestDefinition)
   ON_CBN_SELCHANGE(IDC_CMB_DEFINITION, OnCbnSelchangeCmbDefinition)
   ON_STN_DBLCLK(IDC_LBL_ERROR, OnStnDblclickLblError)
   ON_NOTIFY(TCN_SELCHANGE, IDC_TAB_TRADE_STATISTIC, OnTcnSelchangeTabTradeStatistic)
   ON_CBN_SELCHANGE(IDC_CMB_TRADES, OnCbnSelchangeCmbTrades)
   ON_NOTIFY(LVN_ITEMCHANGED, IDC_LSV_DEF_TRADES, OnLvnItemchangedLsvDefTrades)
   ON_CBN_SELCHANGE(IDC_CMB_LAST_TRADE_ITEMS, OnCbnSelchangeCmbLastTradeItems)
   ON_CBN_SELCHANGE(IDC_CMB_TRADES_ITEMS, OnCbnSelchangeCmbTradesItems)
   ON_NOTIFY(LVN_ITEMCHANGED, IDC_LSV_LAST_TRADES, OnLvnItemchangedLsvLastTrades)
   ON_NOTIFY(LVN_ITEMCHANGED, IDC_LSV_TRADES, OnLvnItemchangedLsvTrades)
END_MESSAGE_MAP()

BOOL CTradingSystemDlg::OnInitDialog()
{
   CDialog::OnInitDialog();

   // Set the icon for this dialog.  The framework does this automatically
   //  when the application's main window is not a dialog
   SetIcon(m_hIcon, TRUE);       // Set big icon
   SetIcon(m_hIcon, FALSE);      // Set small icon

   try
   {
      InitializeControls();
      InitializeCQGCEL();
      ClearAllDefinitionsData();
   }
   catch (std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   return TRUE;  // return TRUE  unless you set the focus to a control
}

void CTradingSystemDlg::OnPaint() 
{
   if (IsIconic())
   {
      CPaintDC dc(this); // device context for painting

      SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

      // Center icon in client rectangle
      int cxIcon = GetSystemMetrics(SM_CXICON);
      int cyIcon = GetSystemMetrics(SM_CYICON);
      CRect rect;
      GetClientRect(&rect);
      int x = (rect.Width() - cxIcon + 1) / 2;
      int y = (rect.Height() - cyIcon + 1) / 2;

      // Draw the icon
      dc.DrawIcon(x, y, m_hIcon);
   }
   else
   {
      CDialog::OnPaint();
   }
}

HCURSOR CTradingSystemDlg::OnQueryDragIcon()
{
   return static_cast<HCURSOR>(m_hIcon);
}

void CTradingSystemDlg::OnOK()
{
   // If enter clicked when one of the tag edit boxes is active
   // then call corresponding function
   CWnd* pWnd = GetFocus();

   if (pWnd == &m_edTagName)
   {
      OnEnterEdTagName();
   }
   else if (pWnd == &m_edTagValue)
   {
      OnEnterEdTagValue();
   }
}

void CTradingSystemDlg::OnDestroy()
{
   try
   {
      if (m_spCQGCEL)
      {
         HRESULT hr = ICQGCELDispEventImpl::DispEventUnadvise(m_spCQGCEL);
         assert(SUCCEEDED(hr));

         hr = m_spCQGCEL->Shutdown();
         Common::ThrowOnCOMError(m_spCQGCEL, hr);
      }
   }
   catch (std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   CDialog::OnDestroy();
}

void CTradingSystemDlg::OnBnClickedBtnRemove()
{
   try
   {
      // Remove selected trading system from the collection
      HRESULT hr = m_spCQGCEL->RemoveTradingSystem(m_spTradingSystem);
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      // Remove item from combo box
      const int row = m_cmbTradingSystem.GetCurSel();
      const int count = m_cmbTradingSystem.DeleteString(row);

      if (0 == count)
      {
         ClearAllData();
         m_spTradingSystem.Release();

         // Clear combo box
         m_cmbTradingSystem.ResetContent();
      }
      else
      {
         m_cmbTradingSystem.SetCurSel((row >= count ? (count - 1) : row));
         OnCbnSelChangeCmbTradingSystem();
      }

      EnableControls();
   }
   catch (std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTradingSystemDlg::OnBnClickedBtnRemoveAll()
{
   try
   {
      // Clear combo box
      m_cmbTradingSystem.ResetContent();

      // Remove all trading systems from CQGCEL
      HRESULT hr = m_spCQGCEL->RemoveAllTradingSystems();
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      m_spTradingSystem.Release();

      ClearAllData();

      EnableControls();
   }
   catch (std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTradingSystemDlg::OnCbnSelChangeCmbTradingSystem()
{
   try
   {
      ClearAllData();

      if (0 < m_cmbTradingSystem.GetCount())
      {
         // Get GUID from combo box
         CString id;
         m_cmbTradingSystem.GetWindowText(id);

         // Get item from CQGCEL by GUID
         ATL::CComPtr<ICQGTradingSystems> spTradingSystems;
         HRESULT hr = m_spCQGCEL->get_AllTradingSystems(&spTradingSystems);
         Common::ThrowOnCOMError(m_spCQGCEL, hr);

         m_spTradingSystem.Release();
         hr = spTradingSystems->get_ItemById(ATL::CT2W(id), &m_spTradingSystem);
         Common::ThrowOnCOMError(spTradingSystems, hr);

         // Show corresponding items all data
         ShowAllData();
      }

      EnableControls();
   }
   catch (std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTradingSystemDlg::OnBnClickedBtnRequestDefinition()
{
   try
   {
      HRESULT hr = m_spCQGCEL->RequestTradingSystemDefinitions();
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      ClearAllDefinitionsData();
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTradingSystemDlg::OnCbnSelchangeCmbDefinition()
{
   try
   {
      const long idx = static_cast<long>(m_cmbDefinition.GetItemData(m_cmbDefinition.GetCurSel()));

      // Get selected trading system definition
      ATL::CComPtr<ICQGTradingSystemDefinition> spTradingSystemDefinition;
      HRESULT hr = m_spTradingSystemDefinitions->get_Item(idx, &spTradingSystemDefinition);
      Common::ThrowOnCOMError(m_spTradingSystemDefinitions, hr);

      // Set definition name in the edit box
      ATL::CComBSTR name;
      hr = spTradingSystemDefinition->get_Name(&name);
      Common::ThrowOnCOMError(spTradingSystemDefinition, hr);

      m_edDefinitionName.SetWindowText(ATL::CW2T(name));

      // Clear definition fields
      ClearDefinitionData();

      // Show definition parameters
      ATL::CComBSTR abbreviation;
      hr = spTradingSystemDefinition->get_Abbreviation(&abbreviation);
      Common::ThrowOnCOMError(spTradingSystemDefinition, hr);

      double commission;
      hr = spTradingSystemDefinition->get_Commission(&commission);
      Common::ThrowOnCOMError(spTradingSystemDefinition, hr);

      eTradingSystemCommissionType commissionType;
      hr = spTradingSystemDefinition->get_CommissionType(&commissionType);
      Common::ThrowOnCOMError(spTradingSystemDefinition, hr);

      m_lblDefAbbreviation.SetWindowText(ATL::CW2T(abbreviation));
      m_lblDefCommission.SetWindowText(GetValueAsString(commission));
      m_lblDefCommissionType.SetWindowText(CHelper::TradingSystemCommissionTypeToString(commissionType));

      // Fill up trades
      ShowDefinitionTrades(spTradingSystemDefinition);

      // Fill up parameters
      ShowDefinitionParameters(spTradingSystemDefinition);
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTradingSystemDlg::OnBnClickedBtnRequest()
{
   try
   {
      // Get trading system definition name
      CString tradingSystemName;
      m_edDefinitionName.GetWindowText(tradingSystemName);

      // Create empty request
      ATL::CComPtr<ICQGTradingSystemRequest> spRequest;
      HRESULT hr = m_spCQGCEL->CreateTradingSystemRequest(ATL::CT2W(tradingSystemName), &spRequest);
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      spRequest->put_SessionsFilter(ATL::CComVariant(31));  // In other words "all sessions". 31 is represented by "11111" bits, where each bit designates a session in "Chart Preference"/"Sessions".

      // Get line time from CQGCEL->Environment
      ATL::CComPtr<ICQGEnvironment> spEnvironment;
      hr = m_spCQGCEL->get_Environment(&spEnvironment);
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      DATE lineTime;
      hr = spEnvironment->get_LineTime(&lineTime);
      Common::ThrowOnCOMError(spEnvironment, hr);

      // Open form to fill up request data
      CTradingSystemReqDlg dlg(spRequest, lineTime);
      if (IDOK == dlg.DoModal())
      {
         // Send request to CQGCEL
         ATL::CComPtr<ICQGTradingSystem> spTradingSystem;
         hr = m_spCQGCEL->RequestTradingSystem(spRequest, &spTradingSystem);
         Common::ThrowOnCOMError(m_spCQGCEL, hr);

         // Add ID to the requests combo box
         ATL::CComBSTR tradingSystemID;
         hr = spTradingSystem->get_Id(&tradingSystemID);
         Common::ThrowOnCOMError(spTradingSystem, hr);

         const int row = m_cmbTradingSystem.AddString(ATL::CW2T(tradingSystemID));
         m_cmbTradingSystem.SetCurSel(row);
         OnCbnSelChangeCmbTradingSystem();
      }

      EnableControls();
   }
   catch (std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTradingSystemDlg::OnBnClickedBtnShow()
{
   try
   {
      // Clear records and records count
      if (toStatistics == m_tabTradeStatistic.GetCurSel())
      {
         ClearRecords(m_lvStatistics);
         m_lblStatsFltrRecsCount.SetWindowText(_T(""));
      }
      else
      {
         ClearRecords(m_lvTrades);
         m_lblTradesFltrRecsCount.SetWindowText(_T(""));
      }

      long startIndex;
      long endIndex;
      bool isValid;

      isValid = GetIndices(startIndex, endIndex);

      // Show filtered records and its' count when range is valid
      if (isValid)
      {
         if (toStatistics == m_tabTradeStatistic.GetCurSel())
         {
            ShowStatisticRecords(startIndex, endIndex, m_lvStatistics);
            m_lblStatsFltrRecsCount.SetWindowText(GetValueAsString(endIndex - startIndex + 1));
         }
         else
         {
            ShowTradeRecords(startIndex, endIndex, m_lvTrades);
            m_lblTradesFltrRecsCount.SetWindowText(GetValueAsString(endIndex - startIndex + 1));
         }
      }
   }
   catch (std::exception& e) 
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTradingSystemDlg::OnDeltaposSpnStart(
                           NMHDR *pNMHDR,
                           LRESULT *pResult)
{
   try
   {
      LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
      m_edStart.DecreaseValue(pNMUpDown->iDelta);
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   *pResult = 0;
}

void CTradingSystemDlg::OnDeltaposSpnEnd(
                           NMHDR *pNMHDR,
                           LRESULT *pResult)
{
   try
   {
      LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
      m_edEnd.DecreaseValue(pNMUpDown->iDelta);
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   *pResult = 0;
}

void CTradingSystemDlg::OnEnterEdTagName()
{
   try
   {
      CString tagName;
      m_edTagName.GetWindowText(tagName);

      // If there is no tag name specified, then do nothing
      if (tagName.IsEmpty()) 
      {
         return;
      }

      ATL::CComVariant tagValue;
      HRESULT hr = m_spTradingSystem->get_Tag(ATL::CT2W(tagName), &tagValue);
      Common::ThrowOnCOMError(m_spTradingSystem, hr);

      // If there is no tag with specified tag name, tag value will be VT_EMPTY
      m_edTagValue.SetWindowText((VT_EMPTY != tagValue.vt) ? GetValueAsString(tagValue) : _T(""));
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTradingSystemDlg::OnEnterEdTagValue()
{
   try
   {
      CString tagName;
      m_edTagName.GetWindowText(tagName);

      // If there is no tag name specified, then do nothing
      if (tagName.IsEmpty())
      {
         return;
      }

      CString tagValue;
      m_edTagValue.GetWindowText(tagValue);

      // If there is no tag value specified, then remove tag with specified tag name
      HRESULT hr = m_spTradingSystem->put_Tag(ATL::CT2W(tagName), 
         tagValue.IsEmpty() ? ATL::CComVariant() : ATL::CComVariant(tagValue));
      Common::ThrowOnCOMError(m_spTradingSystem, hr);

      m_edTagName.SetWindowText(_T(""));
      m_edTagValue.SetWindowText(_T(""));

      m_edTagName.SetFocus();
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTradingSystemDlg::OnStnDblclickLblError()
{
   try
   {
      // If there is no trading system selected do nothing
      if (!m_spTradingSystem)
      {
         return;
      }
   
      // Get request from trading system
      ATL::CComPtr<ICQGTradingSystemRequest> spRequest;
      HRESULT hr = m_spTradingSystem->get_Request(&spRequest);
      Common::ThrowOnCOMError(m_spTradingSystem, hr);

      // Get error from trading system and show it if exist
      ATL::CComPtr<ICQGError> spError;
      hr = m_spTradingSystem->get_LastError(&spError);
      Common::ThrowOnCOMError(m_spTradingSystem, hr);

      VARIANT_BOOL isValid;
      hr = m_spCQGCEL->IsValid(ATL::CComVariant(spError), &isValid);
      Common::ThrowOnCOMError(m_spCQGCEL, hr);

      if (isValid)
      {
         ATL::CComBSTR errDescription;
         hr = spError->get_Description(&errDescription);
         Common::ThrowOnCOMError(spError, hr);

         m_lblError.SetWindowText(ATL::CW2T(errDescription));

         AfxMessageBox(ATL::CW2T(errDescription), MB_ICONEXCLAMATION);
      }
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTradingSystemDlg::OnTcnSelchangeTabTradeStatistic(
                           NMHDR *pNMHDR,
                           LRESULT *pResult)
{
   UNREFERENCED_PARAMETER(pNMHDR);

   try
   {
      ShowListViews();
      FillIndices();
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   *pResult = 0;
}

void CTradingSystemDlg::OnCbnSelchangeCmbTrades()
{
   try
   {
      // Clear list boxes
      ClearRecords(m_lvTrades);
      ClearRecords(m_lvLastTrades);

      ClearRecords(m_lvLastTradeItems);
      ClearRecords(m_lvTradeItems);

      // Clear trades all records count
      m_lblTradesAllRecsCount.SetWindowText(_T(""));
      m_lblTradesFltrRecsCount.SetWindowText(_T(""));

      // Clear headers
      ClearTradeHeaders(m_lvTrades);
      ClearTradeHeaders(m_lvLastTrades);

      // Show headers
      ShowTradeHeaders(m_lvTrades);
      ShowTradeHeaders(m_lvLastTrades);

      // Add trade items
      AddTradeItemsNames(m_cmbLastTradeItems);
      AddTradeItemsNames(m_cmbTradeItems);

      // Show trades
      ShowLastTrades();
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTradingSystemDlg::OnLvnItemchangedLsvDefTrades(
                           NMHDR *pNMHDR,
                           LRESULT *pResult)
{
   try
   {
      LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

      if ((pNMLV->uNewState & LVIS_SELECTED) != LVIS_SELECTED)
      {
         // If there is no new item selected then do nothing
         return;
      }

      // Clear list view
      m_lvDefEntryExits.DeleteAllItems();

      if (!m_spTradingSystemDefinitions)
      {
         return;
      }

      // Get selected trading system definition
      long idx = static_cast<long>(m_cmbDefinition.GetItemData(m_cmbDefinition.GetCurSel()));

      ATL::CComPtr<ICQGTradingSystemDefinition> spTradingSystemDefinition;
      HRESULT hr = m_spTradingSystemDefinitions->get_Item(idx, &spTradingSystemDefinition);
      Common::ThrowOnCOMError(m_spTradingSystemDefinitions, hr);

      ATL::CComPtr<ICQGTradingSystemTradeDefinitions> spTradeDefinitions;
      hr = spTradingSystemDefinition->get_TradeDefinitions(&spTradeDefinitions);
      Common::ThrowOnCOMError(spTradingSystemDefinition, hr);

      // Get selected trade definition
      idx = static_cast<long>(m_lvDefTrades.GetItemData(pNMLV->iItem));
      ATL::CComPtr<ICQGTradingSystemTradeDefinition> spTradeDefinition;
      hr = spTradeDefinitions->get_Item(idx, &spTradeDefinition);
      Common::ThrowOnCOMError(spTradeDefinitions, hr);

      // Show selected trades' properties
      ShowDefinitionTradeEntryExits(spTradeDefinition);
   }
   catch (std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }

   *pResult = 0;
}

void CTradingSystemDlg::OnCbnSelchangeCmbLastTradeItems()
{
   ShowTradeItemRelations(m_lvLastTrades, m_lvLastTradeItems, m_cmbLastTradeItems);
}

void CTradingSystemDlg::OnCbnSelchangeCmbTradesItems()
{
   ShowTradeItemRelations(m_lvTrades, m_lvTradeItems, m_cmbTradeItems);
}

void CTradingSystemDlg::OnLvnItemchangedLsvLastTrades(
                           NMHDR *pNMHDR, 
                           LRESULT *pResult)
{
   try
   {
      LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

      if (LVIS_SELECTED != (pNMLV->uNewState & LVIS_SELECTED))
      {
         // If there is no new item selected then do nothing
         return;
      }

      ShowTradeItemRelations(m_lvLastTrades, m_lvLastTradeItems, m_cmbLastTradeItems);

      *pResult = 0;
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}

void CTradingSystemDlg::OnLvnItemchangedLsvTrades(
                           NMHDR *pNMHDR, 
                           LRESULT *pResult)
{
   try
   {
      LPNMLISTVIEW pNMLV = reinterpret_cast<LPNMLISTVIEW>(pNMHDR);

      if (LVIS_SELECTED != (pNMLV->uNewState & LVIS_SELECTED))
      {
         // If there is no new item selected then do nothing
         return;
      }

      ShowTradeItemRelations(m_lvTrades, m_lvTradeItems, m_cmbTradeItems);

      *pResult = 0;
   }
   catch (const std::exception& e)
   {
      AfxMessageBox(ATL::CA2T(e.what()), MB_ICONSTOP);
   }
}
